#!/usr/bin/env python
#-*-coding:utf-8 -*-
"""
给定一个二叉搜索树, 找到该树中两个指定节点的最近公共祖先。
百度百科中最近公共祖先的定义为：
“对于有根树 T 的两个结点 p、q，最近公共祖先表示为一个结点 x，
满足 x 是 p、q 的祖先且 x 的深度尽可能大（一个节点也可以是它自己的祖先）。”
例如，给定如下二叉搜索树:  root = [6,2,8,0,4,7,9,null,null,3,5]
示例 1:输入: root = [6,2,8,0,4,7,9,null,null,3,5],
p = 2, q = 8 输出: 6
解释: 节点 2 和节点 8 的最近公共祖先是 6。
示例 2:输入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4 输出: 2
解释: 节点 2 和节点 4 的最近公共祖先是 2,
因为根据定义最近公共祖先节点可以为节点本身。 说明:所有节点的值都是唯一的。p、q 为不同节点且均存在于给定的二叉搜索树中。

思路:
这题可以通过递归来调用
1、如果给出的结点大于p. 小于q 那么这个数就为给出p,q 的根结点。
2、如果给出的结点为大于p,q 那么这个结点在左子数
3、如果给出的结点为小于p,q 那么这个结点在右子数
"""
# Definition for a binary tree node.
# class TreeNode(object):
    # def __init__(self, x):
    #    self.val = x
    #    self.left = None
    #    self.right = None
class Solution(object):
 def lowestCommonAncestor(self, root, p, q):
     """
    :type root: TreeNode
    :type p: TreeNode
    :type q: TreeNode
    :rtype: TreeNode
     """
     if root is None:
         return None
     elif root.value > max(p,q):
         return self.lowestCommonAncestor(root.left,p,q)
     elif root.value < min(p,q):
         return self.lowestCommonAncestor(root.right,p,q)
     else:
         return root.value



