#!/usr/bin/env python
#-*-coding:utf-8 -*-
"""
给定一个数组，它的第 i 个元素是一支给定股票第 i 天的价格。
如果你最多只允许完成一笔交易（即买入和卖出一支股票），
设计一个算法来计算你所能获取的最大利润。
注意:
你不能在买入股票前卖出股票。
示例 1:输入: [7,1,5,3,6,4]输出: 5解释: 在第 2 天（股票价格 = 1）的时候买入，
在第 5 天（股票价格 = 6）的时候卖出，最大利润 = 6-1 = 5 。
注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格。
示例 2:输入: [7,6,4,3,1]输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
思路：追求最大利润化就是两两相减求最大值
"""
#方法一
#测试可以得出结果，但时间复杂度较高 O(n2)
class Solution:
    def maxProfit(self, prices):
        l = len(prices)
        maxVal = 0
        for i in range(l-1):
            for j in range(i+1,l):
                val = prices[j] - prices[i]
                if val < 0:
                    val = 0
                maxVal = max(maxVal, val)
        return maxVal
    #方法2 时间复杂度O(n)
    def maxProfit2(self, prices):
        rs = 0
        start_val = prices[0]
        for i in prices:
            rs = max(rs,i-start_val)
            start_val = min(start_val,i)
        return rs
lst = [7,1,5,3,6,4]
s = Solution()
r = s.maxProfit(lst)
print(r)
rs = s.maxProfit2(lst)
print(rs)